<?php

namespace Modules\PLA\Controllers;

class Requisicao {
    protected $connection;
    protected $environment;
    protected $newCodeNT;
    protected $Utils;
    public function __construct($connection, $environment, $newCodeNT, $UtilsIntegracao){
        $this->connection = $connection;
        $this->environment = $environment;
        $this->newCodeNT = $newCodeNT;
        $this->Utils = $UtilsIntegracao;
    }

    public function endpointGetRequisicao($request, $response){
        try{
            $cdfilial = $this->Utils->parametro($request, 'CDFILIAL');
            $dtinicial = $this->Utils->parametro($request, 'DTINICIAL');
            if(!strtotime($dtinicial)){
                $this->Utils->incluiMensagem("Data incial ( $dtinicial ) não é um valor válido", true);
            }
            $dtfinal =$this->Utils->parametro($request, 'DTFINAL');
            if(!strtotime($dtfinal)){
                $this->Utils->incluiMensagem("Data final ( $dtfinal ) não é um valor válido", true);
            }
            $cdservfili = $this->Utils->parametro($request, 'CDSERVFILI');
            
            $query = "
            SELECT PR.CDFILIAL, PR.CDSERVFILI, TO_CHAR(PR.DTPREVRETI, 'YYYYMMDD') AS DTPREVRETI, 
                   PR.CDPRODUTO, PT.NMPRODUTO, PT.CDBARPRODUTO,
                   CASE WHEN NVL(PR.QTPREVLIB, 0.00) <= 0 THEN PR.QTPREVRETI ELSE PR.QTPREVLIB END AS QTPREVLIB
              FROM PREVRETI PR LEFT JOIN PRODUTO PT ON PT.CDPRODUTO = PR.CDPRODUTO
             WHERE (PR.CDFILIAL = :CDFILIAL)
               AND ((PR.CDSERVFILI = :CDSERVFILI) OR (:CDSERVFILI IS NULL))
               AND (PR.DTPREVRETI BETWEEN TO_DATE(:DTINICIAL, 'YYYYMMDD') AND TO_DATE(:DTFINAL, 'YYYYMMDD') )
               AND (PR.NRREQUEXTR = '0000000000')
               AND PR.QTPREVRETI > 0
             ORDER BY PR.CDFILIAL, PR.CDSERVFILI, PR.DTPREVRETI, PT.CDARVPROD
            ";
            $params = [
                "CDFILIAL" => $cdfilial,
                "DTINICIAL" => $dtinicial,
                "DTFINAL" => $dtfinal,
                "CDSERVFILI" => $cdservfili
            ];
            
            if($this->Utils->statusAtual() == 'E'){
                $this->Utils->retornoJSONStatusMensagem($response);
                return;    
            }
            
            $prepared = $this->connection->prepare($query);
            $prepared->execute($params);
            $data = $prepared->fetchAll();
            $this->Utils->retornoJSON($response, $data);
        }catch(\Exception $e){
            if($this->Utils->modoDesenvolvedor())
                throw $e;
            $this->Utils->incluiMensagem("Ocorreu um erro não esperado na execução da rotina. Verifique os parâmetros e tente novamente", true);
            $this->Utils->retornoJSONStatusMensagem($response);
        }
    }
}