<?php

/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  luistavares
 */
class MestreLogic{


    const ERRO_NOVOMESTRE = 'Ocorreu um erro ao gerar o mestre!';
    const ERRO_DESTROIMESTRE = 'Ocorreu um erro ao apagar o mestre!';


    /**
     * Gera um novo mestre para o registro que est sendo inserido no Historico.
     *
     * @param integer $nrorgTrab Nr Org.
     * @param string  $entity    Nome Entity.
     * @param integer $fk        Valor da Foreign Key da atual Tabela.
     *
     * @return integer
     *
     * @author  luistavares 04/08/2011
     *          luistavares 10/08/2011 - Mtodo reescrito para se tornar genrico
     *          luistavares 12/08/2011 - Includo campo para Foreign Key das tables: Vinculo, Estrutura e Pessoa.
     *          luistavares 16/08/2011 - Classe refatorada para funcinar tambm com tabelas com FK.
     *          luistavares 23/08/2011 - Consertado o eval (estava faltando parenteses).
     *          alessandrobartels 19/09/2011 - Criada funcao retornaPK() - Pega a PK da tabela generica
     *          							   gerada pelo strategy.
     */
    public function criaMestre($nrorgTrab, $entity, $fk){
        try{
            eval('$mestre = new '.$entity.'();');
            if ($fk === -1) {
                // Metodo generico utilizado nas tabelas com mestre / historico.
                $mestre_incluido = $mestre->novoMestre($chave, $nrorgTrab);
            } else {
                $mestre_incluido = $mestre->novoMestre($chave, $fk, $nrorgTrab);
            }

            if ($mestre_incluido === true) {
                // Metodo generico utilizado nas tabelas com mestre / historico.
                return $mestre->retornaPK($nrorgTrab);
            } else {
                return $this::ERRO_NOVOMESTRE;
            }
        }
        catch(Exception $e){
            return $this::ERRO_NOVOMESTRE;
        }
    }


    /**
     * Destroi o Cargom do registro que est sendo apagado de GPE_CARGOH.
     *
     * @param integer $chave     Chave da tabela.
     * @param integer $nrorgTrab Nr Org.
     * @param string  $entity    Nome Entity.
     *
     * @return boolean
     *
     * @author luistavares 05/08/2011
     *         luistavares 10/08/2011 - Mtodo reescrito para se tornar genrico
     */
    public function destroiMestre($chave, $nrorgTrab, $entity){
        try{
            $mestre = new $entity();
            if ($chave !== '') {
                tk_delete_row();
                $mestre_excluido = $mestre->destroiMestre($chave, $nrorgTrab);
                if ($mestre_excluido === true) {
                    return true;
                } else {
                    return $this::ERRO_DESTROIMESTRE;
                }
            } else {
                tk_delete_row();
                return true;
            }
        }
        catch(Exception $e){
            return $this::ERRO_DESTROIMESTRE;
        }
    }


}