/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SALA                                                     */
/* Tabela : SALA                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 05/07/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SALA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SALA
GO

CREATE TRIGGER DTULTATU_SALA
ON SALA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
               (SELECT 'SALA',CDFILIAL, 'CDFILIAL='  +CDFILIAL + ';' +'CDSALA='+ CDSALA +';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))FROM DELETED);

   END
   ELSE BEGIN
      UPDATE SALA
      SET DTULTATUSALA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(SALA.CDFILIAL,0)= ISNULL(INSERTED.CDFILIAL,0))AND
            (ISNULL(SALA.CDSALA,0)  = ISNULL(INSERTED.CDSALA,0));
   END;
END;
GO

UPDATE SALA SET DTULTATUSALA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUSALA IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUSALA' and
            type = 'D')
   ALTER TABLE SALA DROP CONSTRAINT DEFAULT_DTULTATUSALA
GO

ALTER TABLE SALA ADD CONSTRAINT DEFAULT_DTULTATUSALA
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUSALA
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SALA','4.11.210';
GO

